Module javafx.base
Package javafx.beans.value

# Interface ObservableValue<T>

Type Parameters:
  `T` - The type of the wrapped value.

All Superinterfaces:
  `Observable`

All Known Subinterfaces:
  `Binding<T>`, `JavaBeanProperty<T>`, `NumberBinding`, `NumberExpression`, `ObservableBooleanValue`, `ObservableDoubleValue`, `ObservableFloatValue`, `ObservableIntegerValue`, `ObservableListValue<E>`, `ObservableLongValue`, `ObservableMapValue<K,V>`, `ObservableNumberValue`, `ObservableObjectValue<T>`, `ObservableSetValue<E>`, `ObservableStringValue`, `Property<T>`, `ReadOnlyJavaBeanProperty<T>`, `ReadOnlyProperty<T>`, `TextInputControl.Content`

All Known Implementing Classes:
  `BooleanBinding`, `BooleanExpression`, `BooleanProperty`, `BooleanPropertyBase`, `DoubleBinding`, `DoubleExpression`, `DoubleProperty`, `DoublePropertyBase`, `FloatBinding`, `FloatExpression`, `FloatProperty`, `FloatPropertyBase`, `IntegerBinding`, `IntegerExpression`, `IntegerProperty`, `IntegerPropertyBase`, `JavaBeanBooleanProperty`, `JavaBeanDoubleProperty`, `JavaBeanFloatProperty`, `JavaBeanIntegerProperty`, `JavaBeanLongProperty`, `JavaBeanObjectProperty`, `JavaBeanStringProperty`, `ListBinding`, `ListExpression`, `ListProperty`, `ListPropertyBase`, `LongBinding`, `LongExpression`, `LongProperty`, `LongPropertyBase`, `MapBinding`, `MapExpression`, `MapProperty`, `MapPropertyBase`, `NumberExpressionBase`, `ObjectBinding`, `ObjectExpression`, `ObjectProperty`, `ObjectPropertyBase`, `ObservableValueBase`, `ReadOnlyBooleanProperty`, `ReadOnlyBooleanPropertyBase`, `ReadOnlyBooleanWrapper`, `ReadOnlyDoubleProperty`, `ReadOnlyDoublePropertyBase`, `ReadOnlyDoubleWrapper`, `ReadOnlyFloatProperty`, `ReadOnlyFloatPropertyBase`, `ReadOnlyFloatWrapper`, `ReadOnlyIntegerProperty`, `ReadOnlyIntegerPropertyBase`, `ReadOnlyIntegerWrapper`, `ReadOnlyJavaBeanBooleanProperty`, `ReadOnlyJavaBeanDoubleProperty`, `ReadOnlyJavaBeanFloatProperty`, `ReadOnlyJavaBeanIntegerProperty`, `ReadOnlyJavaBeanLongProperty`, `ReadOnlyJavaBeanObjectProperty`, `ReadOnlyJavaBeanStringProperty`, `ReadOnlyListProperty`, `ReadOnlyListPropertyBase`, `ReadOnlyListWrapper`, `ReadOnlyLongProperty`, `ReadOnlyLongPropertyBase`, `ReadOnlyLongWrapper`, `ReadOnlyMapProperty`, `ReadOnlyMapPropertyBase`, `ReadOnlyMapWrapper`, `ReadOnlyObjectProperty`, `ReadOnlyObjectPropertyBase`, `ReadOnlyObjectWrapper`, `ReadOnlySetProperty`, `ReadOnlySetPropertyBase`, `ReadOnlySetWrapper`, `ReadOnlyStringProperty`, `ReadOnlyStringPropertyBase`, `ReadOnlyStringWrapper`, `SetBinding`, `SetExpression`, `SetProperty`, `SetPropertyBase`, `SimpleBooleanProperty`, `SimpleDoubleProperty`, `SimpleFloatProperty`, `SimpleIntegerProperty`, `SimpleListProperty`, `SimpleLongProperty`, `SimpleMapProperty`, `SimpleObjectProperty`, `SimpleSetProperty`, `SimpleStringProperty`, `SimpleStyleableBooleanProperty`, `SimpleStyleableDoubleProperty`, `SimpleStyleableFloatProperty`, `SimpleStyleableIntegerProperty`, `SimpleStyleableLongProperty`, `SimpleStyleableObjectProperty`, `SimpleStyleableStringProperty`, `StringBinding`, `StringExpression`, `StringProperty`, `StringPropertyBase`, `StyleableBooleanProperty`, `StyleableDoubleProperty`, `StyleableFloatProperty`, `StyleableIntegerProperty`, `StyleableLongProperty`, `StyleableObjectProperty`, `StyleableStringProperty`

public interface ObservableValue<T> extends Observable
An `ObservableValue` is an entity that wraps a value and allows to observe the value for changes. In general this interface should not be implemented directly but one of its sub-interfaces (`ObservableBooleanValue` etc.).

The value of the `ObservableValue` can be requested with `getValue()`.

An implementation of `ObservableValue` may support lazy evaluation, which means that the value is not immediately recomputed after changes, but lazily the next time the value is requested. All bindings and properties in this library support lazy evaluation.

An `ObservableValue` generates two types of events: change events and invalidation events. A change event indicates that the value has changed. An invalidation event is generated if the current value is not valid anymore. This distinction becomes important if the `ObservableValue` supports lazy evaluation, because for a lazily evaluated value one does not know if an invalid value really has changed until it is recomputed. For this reason, generating change events requires eager evaluation while invalidation events can be generated for eager and lazy implementations.

Implementations of this class should strive to generate as few events as possible to avoid wasting too much time in event handlers. Implementations in this library mark themselves as invalid when the first invalidation event occurs. They do not generate anymore invalidation events until their value is recomputed and valid again.

Two types of listeners can be attached to an `ObservableValue`: `InvalidationListener` to listen to invalidation events and `ChangeListener` to listen to change events.

Important note: attaching a `ChangeListener` enforces eager computation even if the implementation of the `ObservableValue` supports lazy evaluation.

Since:
  JavaFX 2.0
See Also:
  - `ObservableBooleanValue`
  - `ObservableDoubleValue`
  - `ObservableFloatValue`
  - `ObservableIntegerValue`
  - `ObservableLongValue`
  - `ObservableNumberValue`
  - `ObservableObjectValue`
  - `ObservableStringValue`

## Method Summary

Modifier and Type
Method
Description
`void`
`addListener(ChangeListener<? super T> listener)`
Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
`T`
`getValue()`
Returns the current value of this `ObservableValue`
`void`
`removeListener(ChangeListener<? super T> listener)`
Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

### Methods inherited from interface javafx.beans.Observable

`addListener, removeListener`

## Method Details

### addListener

void addListener(ChangeListener<? super T> listener)
Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

Parameters:
  `listener` - The listener to register
Throws:
  `NullPointerException` - if the listener is null
See Also:
  - `removeListener(ChangeListener)`

### removeListener

void removeListener(ChangeListener<? super T> listener)
Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

Parameters:
  `listener` - The listener to remove
Throws:
  `NullPointerException` - if the listener is null
See Also:
  - `addListener(ChangeListener)`

### getValue

T getValue()
Returns the current value of this `ObservableValue`

Returns:
  The current value